package client;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.net.Socket;

import json.JSONWriter;

/*
 * Note: The STORE, GET, CHANGE, END commands are
 * so that the server can recognize the operations
 * the client wants.
 */
public class Client{
	public static void main(String[] args){
		try{
		//Standard socket code, recall this from the earlier lab
		Socket mySocket = new Socket("localhost", 15214);
		PrintWriter out = new PrintWriter(mySocket.getOutputStream(), true);
        BufferedReader in = new BufferedReader(new InputStreamReader(mySocket.getInputStream()));
        
        //Create a JSONObject with key "patrick" mapping to value "cat"
		StringWriter myWriter = new StringWriter();
		JSONWriter jsonW = new JSONWriter(myWriter);
		jsonW.object();//start object (refer to JSONWriter javadoc for a more in depth explanation of creation)
			jsonW.key("username");//key
				jsonW.value("patrick");//value at key
			jsonW.key("animal");//key
				jsonW.value("cat");//value at key
		jsonW.endObject();//finish object
		String message = myWriter.toString();//creates a string serializing the object
		
		out.println("STORE "+message);//send the JSON to the server, along with a request to STORE it.
		System.out.println(in.readLine());
		
		out.println("GET patrick");//request the information for "patrick"
		System.out.println(in.readLine());
		
		//Create a JSONObject with key "patrick" mapping to value "dog"
		myWriter = new StringWriter();
		jsonW = new JSONWriter(myWriter);
		jsonW.object();//start object
			jsonW.key("username");//key
				jsonW.value("patrick");//value at key
			jsonW.key("animal");//another key
				jsonW.value("dog");//dog
		jsonW.endObject();//finish object
		message = myWriter.toString();//creates a string serializing the object
		
		out.println("CHANGE "+message);//send a change with a JSON object
		System.out.println(in.readLine());
		
		out.println("GET patrick");//request the information for "patrick"
		System.out.println(in.readLine());
		
		out.println("END");//close connection
		System.out.println(in.readLine());
		
		in.close();
		out.close();
		mySocket.close();
		
		}catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	
		
	}

}
