package db;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;



public class FavAnimalData extends SQLiteAdapter {

	public FavAnimalData() throws Exception {
		super();
	}
	
	public ArrayList<String> favAnimal(String userName){
		ResultSet rs = null;
		ArrayList<String> ret = new ArrayList<String>();//There could be more than one with a certain username, get all rows
		try {
								//get everything from the table Info where the username= ?
			String statement = "SELECT * FROM " + "Info" + " WHERE username=?;";//get all info for username to be designated
			PreparedStatement ps = conn.prepareStatement(statement);
			ps.setString(1, userName);//designates the username (? = userName)
			
			rs = ps.executeQuery();//actually executes the query
			while(rs.next()){//go through the ResultSet
				ret.add(rs.getString("animal"));//get the value at the field "animal" in the row.
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
            try{
            	if(rs != null){
            		rs.close();
            	}
            } catch (SQLException e){
            }
        }
		
		return ret;//return the arraylist. For the purpose of this short example, we only take the first element anyway however.
	}
	public boolean addUserAnimal(String username, String favanimal){
		PreparedStatement ps;
						//insert a row with the fields (username, animal) initialized to (?,?)
		String statement = "INSERT INTO " + "Info" + " (username, animal) VALUES (?, ?)";
		try{
			ps = conn.prepareStatement(statement);
			ps.setString(1, username);//first ? = username
			ps.setString(2, favanimal);//second ? = favanimal
			ps.executeUpdate();//do the update to the table.
		} catch(SQLException e){
			e.printStackTrace();
			return false;
		}
		
		return true;
		
	}
	public boolean changeAnimal(String username, String animal){
		ArrayList<String> lookup = favAnimal(username);
		String s = lookup.get(0);
		if(s == null){//check if the username is in the table, if not then you can't change the field
			return false;
		}
		
		PreparedStatement ps;
		//Update all rows in Info which have username = ? to have the field animal equal to ?
		String statement = "UPDATE " + "Info" + " SET animal=? WHERE username=?";
		try{
			ps = conn.prepareStatement(statement);
			ps.setString(1, animal);// first ? = animal
			ps.setString(2, username);//second ? = username
			ps.executeUpdate();
		} catch(SQLException e){
			return false;
		}
		
		return true;
	}
	
	
	
}
