package server;


import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.ArrayList;

import db.FavAnimalData;

import json.JSONObject;
import json.JSONTokener;



public class ServerThread extends Thread {
	private Socket mySocket;
	private FavAnimalData d;
	public ServerThread(Socket s, FavAnimalData f) throws Exception {
		if (s == null) {
			throw new NullPointerException();
		}
		mySocket = s;
		mySocket.setSoTimeout(600000);
		d = f;
	}
	public void run(){
		try{
			PrintWriter out = new PrintWriter(mySocket.getOutputStream(),
					true);
			BufferedReader in = new BufferedReader(new InputStreamReader(
					mySocket.getInputStream()));
			while(true){//keep accepting messages until END command is given.
				String msg = in.readLine();
				JSONObject o;
				if(msg.indexOf("STORE") == 0){//Recognize the STORE command, store new data
					o = new JSONObject(new JSONTokener(msg.substring(6)));
					d.addUserAnimal(o.getString("username"), o.getString("animal"));
					out.println("successful store");
				}
				else if(msg.indexOf("GET") == 0){//Recognize the GET command, get the data
					ArrayList<String> a = d.favAnimal(msg.substring(4));
					out.println(msg.substring(4) + "'s favorite animal is "+a.get(0));
				}
				else if(msg.indexOf("CHANGE") == 0){//Recognize the CHANGE command, change the data
					o = new JSONObject(new JSONTokener(msg.substring(7)));
					d.changeAnimal(o.getString("username"), o.getString("animal"));
					out.println("successful change");
				}
				else if(msg.indexOf("END") == 0){//Break out of the loop, no longer accept messages
					out.println("closing connection");
					break;
				}
				else{
					out.println("Unrecognized command");
				}
			}
			out.close();
			in.close();
			mySocket.close();
		}catch(Exception e){
			e.printStackTrace();
		}
	}

}
